<?php

App::uses('PluginInstallShell', 'shells');

class EvSiteSettingsInstallShell extends PluginInstallShell
{
	public $uses = array(
		'EvSiteSettings.SiteSetting',
		'EvSiteSettings.SiteSettingCategory'
	);

	/**
	 * call parent run() This will auto run any migrations
	 *
	 * Use the run() method here to insert any content
	 */
	public function run()
	{
		parent::run();

		$this->SiteSettingCategory->saveMany(
			array(
				array(
					'name' => 'General',
					'array_slug' => 'general',
					'sequence' => 10
				),
				array(
					'name' => 'Users',
					'array_slug' => 'users',
					'sequence' => 20
				)
			)
		);

		$this->SiteSetting->saveMany(
			array(
				array(
					'name' => 'Administrator Email',
					'array_slug' => 'admin_email',
					'type' => 'email',
					'options' => null,
					'value' => 'admin@evoluted.net',
					'site_setting_category_id' => 1,
					'sequence' => 10
				),
				array(
					'name' => 'Site Title',
					'array_slug' => 'site_title',
					'type' => 'string',
					'options' => null,
					'value' => 'Evoluted CMS',
					'site_setting_category_id' => 1,
					'sequence' => 20
				),
				array(
					'name' => 'Enable User Registration',
					'array_slug' => 'enable_registration',
					'type' => 'boolean',
					'options' => null,
					'value' => 0,
					'site_setting_category_id' => 2,
					'sequence' => 10
				),
				array(
					'name' => 'User Activation',
					'array_slug' => 'activation',
					'type' => 'select',
					'options' => 'auto:Automatic Activation,email:Email Verification,manual:Manual Activation',
					'value' => 'email',
					'site_setting_category_id' => 2,
					'sequence' => 20
				)
			)
		);
	}
}
